﻿Imports WpfCommandsVbTutorial.Utils

Namespace ViewModels

    Public Class MainViewModel
        Inherits PropertyChangedBase

        Private _user As String

        Public Property User As String
            Get
                Return _user
            End Get
            Set(value As String)
                If _user = value Then
                    Return
                End If
                _user = value
                NotifyOfPropertyChange()
                LoginCommand.RaiseCanExecuteChanged()
            End Set
        End Property

        Private _password As String

        Public Property Password As String
            Get
                Return _password
            End Get
            Set(value As String)
                If _password = value Then
                    Return
                End If
                _password = value
                NotifyOfPropertyChange()
                LoginCommand.RaiseCanExecuteChanged()
            End Set
        End Property

        Public Property LoginCommand As CommandBase

        Private _loginAttempts As Integer

        Public Property LoginAttempts As Integer
            Get
                Return _loginAttempts
            End Get
            Set(value As Integer)
                _loginAttempts = value
                LoginCommand.RaiseCanExecuteChanged()
            End Set
        End Property

        Sub New()
            LoginCommand = New CommandBase(AddressOf Login, AddressOf CanLogin)
        End Sub

        Private Sub Login(parameter As Object)
            'Dim letter = Convert.ToString(parameter)
            'Debug.WriteLine(letter)
            ' Debug.WriteLine("Ich mache eine Anmeldung")
            LoginAttempts += 1
        End Sub

        Private Function CanLogin(parameter As Object) As Boolean
            Return _loginAttempts < 3
            ' Return Not String.IsNullOrEmpty(User) AndAlso Not String.IsNullOrEmpty(Password)
        End Function

    End Class

End Namespace